// ------------------------------------------------------------------
// CDXTetris.cpp : Defines the entry point for the application.
// ------------------------------------------------------------------

// ------------------------------------------------------------------
// Generated by the CDX Application Wizard
// By: Michael Rich [istan@alltel.net]
//
// With valuable help from:
//   Ioannis Karagiorgos, for the debugging help
//   Bil Simser, for the good ideas and constructive criticism
// ------------------------------------------------------------------

#include "StdInclude.h"
#include "Globals.h"
#include "Graphics.h"
#include "UI.h"

#include "resource.h"


// ------------------------------------------------------------------
// cdx_DoFrame - performs drawing of the current frame
// ------------------------------------------------------------------
void doFrame()
{
	int iPlayer;
	switch (g_iGameState) {
	case STATE_INIT:
		g_iGameState = STATE_MAIN;
		break;
	case STATE_MAIN:
		for (iPlayer=0; iPlayer<NUM_PLAYERS; iPlayer++) {
			Tetris[iPlayer]->Update(tmr.GetValue());
		}
		doUI();
		cdx_DoFrame();
		for (iPlayer=0; iPlayer<NUM_PLAYERS; iPlayer++) {
			if (Tetris[iPlayer]->iScore>g_iHighScore)
				g_iHighScore = Tetris[iPlayer]->iScore;
			//if (Tetris[iPlayer]->bDead)
				//Tetris[iPlayer]->Reset();
		}
		break;
	case STATE_DEINIT:
		cdx_DeInit();
		SendMessage(g_hWnd, WM_CLOSE, 0, 0);
		break;
	}
}




// ------------------------------------------------------------------
// WinProc - handles application messages
// ------------------------------------------------------------------
static long PASCAL WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_ACTIVATEAPP:    g_IsAppActive = wParam;     // set if app is active or not
								if (g_IsAppActive)
									tmr.Resume();
								else
									tmr.Pause();
			                    return 0;
		
//		case WM_SETCURSOR:  SetCursor(NULL);    // hide the mouse cursor
//                			return 1;
		case WM_CLOSE:

		case WM_DESTROY:	PostQuitMessage(0);
		                    return 0;

		default:        	return DefWindowProc(hWnd, message, wParam, lParam);
	}
}





// ------------------------------------------------------------------
// InitApp - Create the window and the CDX objects
// ------------------------------------------------------------------
static BOOL InitApp(int nCmdShow)
{
	WNDCLASS WndClass;

	WndClass.style = CS_HREDRAW | CS_VREDRAW;
	WndClass.lpfnWndProc = WinProc;
	WndClass.cbClsExtra = 0;
	WndClass.cbWndExtra = 0;
	WndClass.hInstance = g_hInst;
	WndClass.hIcon = LoadIcon(g_hInst, "APPICON");
	WndClass.hCursor = LoadCursor(0, IDC_ARROW);
	WndClass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	WndClass.lpszMenuName = 0;
	WndClass.lpszClassName = szClassName;
	RegisterClass(&WndClass);

	g_hWnd = CreateWindowEx(
		0,
		szClassName,
		szAppName,
 		WS_OVERLAPPED | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU,
		0,
		0,
		320,
		240,
		NULL,
		NULL,
		g_hInst,
		NULL);

    // when hWnd = -1 there was an error creating the main window
    // CDXError needs a CDXScreen object, if there is none at this early
    // program stage, pass it NULL
	if( !g_hWnd ) 
        CDXError( NULL , "could not create the main window" );


	AdjustWinStyle();

	ShowWindow(g_hWnd, nCmdShow);
	UpdateWindow(g_hWnd);

	return TRUE;
}

// ------------------------------------------------------------------
// WinMain - inital function called by windows
// ------------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	// save the app instance
	g_hInst = hInstance;


	if(!InitApp(nCmdShow)) 
        CDXError( NULL , "could not initialize application" );

	initRand();
	
	if(!cdx_Init())
	{
		PostQuitMessage(0);
		return FALSE;
	}

	while(1)
	{
		if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if(!GetMessage(&msg, NULL, 0, 0 )) return msg.wParam;
			TranslateMessage(&msg); 
			DispatchMessage(&msg);
		}
		else if(g_IsAppActive)
		{
			doFrame();
		}
		else
		{
			WaitMessage();
		}
	}
}
