#include "StdInclude.h"
#include "Tetris.h"
#include "Globals.h"
#include <time.h> // For srand/time

// ------------------------------------------------------------------
// Global Variables
// ------------------------------------------------------------------
char        szAppName[]     = "CDXTetris";
char        szClassName[]   = "CDXTetrisWndClass";

HINSTANCE   g_hInst;			        // instance handle
HWND        g_hWnd;				        // window handle

BOOL        g_IsAppActive;			    // is the app active

// ------------------------------------------------------------------
// CDX Objects
// ------------------------------------------------------------------
CDXScreen   * Screen    = 0;	    // The screen object, every program must have one
CDXInput    * Input     = 0;        // The input object
CDXSurface  * BG		= 0;		// The Background image
CDXTile	    * Tiles		= 0;		// The piece tiles
CDXBitmapFont * ScoreFont=0;

// The Tetris game-logic object
CTetris		* Tetris[NUM_PLAYERS]	= {0};

int iRandNumbers[10000];

int g_iGameState = STATE_INIT;


int g_iHighScore=0;

CDXHPC tmr;


void initRand() {
	srand( (unsigned)time( NULL ) );
	for (int i=0; i<10000; i++) {
		iRandNumbers[i] = rand()%NUMPEICES;
	}
}

int myrand(int iNum) {
	return iRandNumbers[iNum];
}
