// PieceLib.cpp: implementation of the CPieceLib class.
//
//////////////////////////////////////////////////////////////////////

#include "PieceLib.h"
#include <assert.h>
#include <windows.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPieceLib::CPieceLib():m_liCurID(1),m_iType(NULL)
{

	m_iType = new int[MAX_PIECES];

}

CPieceLib::~CPieceLib()
{
	if (m_iType!=NULL) {
		delete m_iType;
		m_iType=NULL;
	}
}

void CPieceLib::Reset()
{
	m_liCurID=1;
	for (int i=0; i<MAX_PIECES; i++) {
		m_iType[i]=0;
	}
}

long CPieceLib::getNewID(int iType)
{
	if (m_liCurID==MAX_PIECES) {
		return -1;
	}
	m_iType[m_liCurID]=iType;
	return m_liCurID++;
}

int CPieceLib::getType(long iPieceID)
{
	assert(iPieceID < m_liCurID);
	return m_iType[iPieceID];

}
